# coding: utf-8

"""
    Skyfire API

    The Skyfire API is designed to allow agents to interact with the Skyfire platform to enable autonomous payments.

    The version of the OpenAPI document: 1.0.0
    Contact: support@skyfire.xyz
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Union
from skyfire_sdk.models.reloadly_gift_card_response_product_brand import ReloadlyGiftCardResponseProductBrand
from typing import Optional, Set
from typing_extensions import Self

class ReloadlyGiftCardResponseProduct(BaseModel):
    """
    ReloadlyGiftCardResponseProduct
    """ # noqa: E501
    brand: ReloadlyGiftCardResponseProductBrand
    currency_code: StrictStr = Field(alias="currencyCode")
    total_price: Union[StrictFloat, StrictInt] = Field(alias="totalPrice")
    unit_price: Union[StrictFloat, StrictInt] = Field(alias="unitPrice")
    quantity: Union[StrictFloat, StrictInt]
    country_code: StrictStr = Field(alias="countryCode")
    product_name: StrictStr = Field(alias="productName")
    product_id: Union[StrictFloat, StrictInt] = Field(alias="productId")
    __properties: ClassVar[List[str]] = ["brand", "currencyCode", "totalPrice", "unitPrice", "quantity", "countryCode", "productName", "productId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ReloadlyGiftCardResponseProduct from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of brand
        if self.brand:
            _dict['brand'] = self.brand.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ReloadlyGiftCardResponseProduct from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "brand": ReloadlyGiftCardResponseProductBrand.from_dict(obj["brand"]) if obj.get("brand") is not None else None,
            "currencyCode": obj.get("currencyCode"),
            "totalPrice": obj.get("totalPrice"),
            "unitPrice": obj.get("unitPrice"),
            "quantity": obj.get("quantity"),
            "countryCode": obj.get("countryCode"),
            "productName": obj.get("productName"),
            "productId": obj.get("productId")
        })
        return _obj


